diff --git a/blivet/devices.py b/blivet/devices.py
index 58a3cb1..14a58a9 100644
--- a/blivet/devices.py
+++ b/blivet/devices.py
@@ -2779,29 +2774,34 @@ class LVMThinPoolDevice(LVMLogicalVolumeDevice):
                  format=None, exists=False, sysfsPath='',
                  grow=None, maxsize=None, percent=None,
                  metadatasize=None, chunksize=None):
-        """ Create a LVMLogicalVolumeDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-                parents -- vg (LVMVolumeGroupDevice instance)
-
-            Keyword Arguments:
-
-                size -- the device's size (in MB)
-                uuid -- the device's UUID
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                exists -- indicates whether this is an existing device
-
-                For new (non-existent) LVs only:
-
-                    grow -- whether to grow this LV
-                    maxsize -- maximum size for growable LV (in MB)
-                    percent -- percent of VG space to take
-                    metadatasize -- the size of the metadata LV (in MB)
-                    chunksize -- chunk size for the pool (in MB)
-
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword uuid: the device UUID
+            :type uuid: str
+
+            For non-existent pools only:
+
+            :keyword grow: whether to grow this LV
+            :type grow: bool
+            :keyword maxsize: maximum size for growable LV
+            :type maxsize: :class:`~.size.Size`
+            :keyword percent: percent of VG space to take
+            :type percent: int
+            :keyword metadatasize: the size of the metadata LV
+            :type metadatasize: :class:`~.size.Size`
+            :keyword chunksize: chunk size for the pool
+            :type chunksize: :class:`~.size.Size`
         """
         if metadatasize is not None and \
            not lvm.is_valid_thin_pool_metadata_size(metadatasize):
@@ -2931,23 +2931,28 @@ class MDRaidArrayDevice(StorageDevice):
                  memberDevices=None, totalDevices=None,
                  uuid=None, format=None, exists=False, metadataVersion=None,
                  parents=None, sysfsPath=''):
-        """ Create a MDRaidArrayDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                level -- the device's RAID level (a string, eg: '1' or 'raid1')
-                metadataVersion -- the version of the device's md metadata
-                parents -- list of member devices (StorageDevice instances)
-                size -- the device's size (units/format TBD)
-                uuid -- the device's UUID
-                minor -- the device minor
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                exists -- indicates whether this is an existing device
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword uuid: the device UUID
+            :type uuid: str
+
+            :keyword level: the device's RAID level
+            :type level: str (eg: "raid1")
+            :keyword metadataVersion: the version of the device's md metadata
+            :type metadataVersion: str (eg: "0.90")
+            :keyword minor: the device minor (obsolete?)
+            :type minor: int
         """
         StorageDevice.__init__(self, name, format=format, exists=exists,
                                major=major, minor=minor, size=size,
@@ -3492,19 +3497,22 @@ class DMRaidArrayDevice(DMDevice):
 
     def __init__(self, name, raidSet=None, format=None,
                  size=None, parents=None, sysfsPath=''):
-        """ Create a DMRaidArrayDevice instance.
-
-            Arguments:
-
-                name -- the dmraid name also the device node's basename
-
-            Keyword Arguments:
-
-                raidSet -- the RaidSet object from block
-                parents -- a list of the member devices
-                sysfsPath -- sysfs device path
-                size -- the device's size
-                format -- a DeviceFormat instance
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword raidSet: the RaidSet object from block
+            :type raidSet: :class:`block.RaidSet`
+
+            DMRaidArrayDevices always exist. Blivet cannot create or destroy
+            them.
         """
         if isinstance(parents, list):
             for parent in parents:
@@ -3602,19 +3610,22 @@ class MultipathDevice(DMDevice):
 
     def __init__(self, name, format=None, size=None, serial=None,
                  parents=None, sysfsPath=''):
-        """ Create a MultipathDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                sysfsPath -- sysfs device path
-                size -- the device's size
-                format -- a DeviceFormat instance
-                parents -- a list of the backing devices (Device instances)
-                serial -- the device's serial number
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword serial: the device's serial number
+            :type serial: str
+
+            MultipathDevices always exist. Blivet cannot create or destroy
+            them.
         """
 
         DMDevice.__init__(self, name, format=format, size=size,
@@ -3707,13 +3718,9 @@ class NoDevice(StorageDevice):
     _type = "nodev"
 
     def __init__(self, format=None):
-        """ Create a NoDevice instance.
-
-            Arguments:
-
-            Keyword Arguments:
-
-                format -- a DeviceFormat instance
+        """
+            :keyword format: the device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
         """
         if format:
             name = format.device
@@ -3760,18 +3767,17 @@ class FileDevice(StorageDevice):
 
     def __init__(self, path, format=None, size=None,
                  exists=False, parents=None):
-        """ Create a FileDevice instance.
-
-            Arguments:
-
-                path -- full path to the file
-
-            Keyword Arguments:
-
-                format -- a DeviceFormat instance
-                size -- the file size (units TBD)
-                parents -- a list of required devices (Device instances)
-                exists -- indicates whether this is an existing device
+        """
+            :param path: full path to the file
+            :type path: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
         """
         if not path.startswith("/"):
             raise ValueError("FileDevice requires an absolute path")
@@ -3873,19 +3879,17 @@ class LoopDevice(StorageDevice):
 
     def __init__(self, name=None, format=None, size=None, sysfsPath=None,
                  exists=False, parents=None):
-        """ Create a LoopDevice instance.
-
-            Arguments:
-
-                name -- the device's name
-
-            Keyword Arguments:
-
-                format -- a DeviceFormat instance
-                size -- the device's size in MB
-                parents -- a list of required devices (Device instances)
-                exists -- indicates whether this is an existing device
-
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
 
             Loop devices always exist.
         """
@@ -3958,6 +3962,29 @@ class iScsiDiskDevice(DiskDevice, NetworkStorageDevice):
     _packages = ["iscsi-initiator-utils", "dracut-network"]
 
     def __init__(self, device, **kwargs):
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword node: ???
+            :type node: str
+            :keyword ibft: use iBFT
+            :type ibft: bool
+            :keyword nic: name of NIC to use
+            :type nic: str
+            :keyword initiator: initiator name
+            :type initiator: str
+            :keyword fw_name: qla4xxx partial offload
+            :keyword fw_address: qla4xxx partial offload
+            :keyword fw_port: qla4xxx partial offload
+        """
         self.node = kwargs.pop("node")
         self.ibft = kwargs.pop("ibft")
         self.nic = kwargs.pop("nic")
@@ -4023,6 +4050,20 @@ class FcoeDiskDevice(DiskDevice, NetworkStorageDevice):
     _packages = ["fcoe-utils", "dracut-network"]
 
     def __init__(self, device, **kwargs):
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword nic: name of NIC to use
+            :keyword identifier: ???
+        """
         self.nic = kwargs.pop("nic")
         self.identifier = kwargs.pop("identifier")
         DiskDevice.__init__(self, device, **kwargs)
@@ -4102,6 +4143,21 @@ class ZFCPDiskDevice(DiskDevice):
     _type = "zfcp"
 
     def __init__(self, device, **kwargs):
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword hba_id: ???
+            :keyword wwpn: ???
+            :keyword fcp_lun: ???
+        """
         self.hba_id = kwargs.pop("hba_id")
         self.wwpn = kwargs.pop("wwpn")
         self.fcp_lun = kwargs.pop("fcp_lun")
@@ -4130,6 +4186,21 @@ class DASDDevice(DiskDevice):
     _type = "dasd"
 
     def __init__(self, device, **kwargs):
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword busid: bus ID
+            :keyword opts: options
+            :type opts: dict with option name keys and option value values
+        """
         self.busid = kwargs.pop('busid')
         self.opts = kwargs.pop('opts')
         DiskDevice.__init__(self, device, **kwargs)
@@ -4195,6 +4266,14 @@ class NFSDevice(StorageDevice, NetworkStorageDevice):
     _packages = ["dracut-network"]
 
     def __init__(self, device, format=None, parents=None):
+        """
+            :param device: the device name (generally a device node's basename)
+            :type device: str
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+        """
         # we could make host/ip, path, &c but will anything use it?
         StorageDevice.__init__(self, device, format=format, parents=parents)
         NetworkStorageDevice.__init__(self, device.split(":")[0])
